/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { WebDisplayDensityBaseDescription } from "./WebDisplayDensityBaseDescription";
import { markType } from "./type";
import { WebDisplayDensityBaseElementDescription } from "./WebDisplayDensityBaseElementDescription";
/**
 * @hidden
 */
export let WebGridBaseDirectiveDescription = /*@__PURE__*/ (() => {
    class WebGridBaseDirectiveDescription extends WebDisplayDensityBaseDescription {
        constructor() {
            super();
            this.bm = 0;
            this.as = false;
            this.ay = false;
            this.cu = null;
            this.bz = null;
            this.da = null;
            this.bn = 0;
            this.w = null;
            this.ae = null;
            this.cv = null;
            this.dc = null;
            this.dn = null;
            this.d6 = null;
            this.dh = null;
            this.u = null;
            this.cr = null;
            this.cs = null;
            this.co = null;
            this.dz = null;
            this.dm = null;
            this.dv = null;
            this.d0 = null;
            this.dp = null;
            this.c8 = null;
            this.c7 = null;
            this.cw = null;
            this.cx = null;
            this.ea = null;
            this.eb = null;
            this.ec = null;
            this.ed = null;
            this.o = null;
            this.m = null;
            this.ag = null;
            this.c1 = null;
            this.z = null;
            this.y = null;
            this.db = null;
            this.df = null;
            this.az = false;
            this.bk = 0;
            this.bl = 0;
            this.av = false;
            this.a0 = false;
            this.el = null;
            this.bu = null;
            this.a1 = false;
            this.bv = null;
            this.cj = null;
            this.ct = null;
            this.aw = false;
            this.a3 = false;
            this.cq = null;
            this.am = null;
            this.ar = false;
            this.aq = false;
            this.c2 = null;
            this.ei = null;
            this.eh = null;
            this.a4 = false;
            this.ac = null;
            this.ai = null;
            this.ao = null;
            this.d9 = null;
            this.c9 = null;
            this.d5 = null;
            this.cp = null;
            this.n = null;
            this.at = false;
            this.b6 = null;
            this.d3 = null;
            this.cf = null;
            this.ax = false;
            this.ak = null;
            this.l = null;
            this.bo = 0;
            this.au = false;
            this.a2 = false;
            this.k = null;
            this.c0 = null;
            this.b0 = null;
            this.c6 = null;
            this.dd = null;
            this.dg = null;
            this.b1 = null;
            this.c3 = null;
            this.ek = null;
            this.d8 = null;
            this.d4 = null;
            this.cg = null;
            this.cb = null;
            this.cc = null;
            this.b4 = null;
            this.b5 = null;
            this.b2 = null;
            this.b3 = null;
            this.dx = null;
            this.du = null;
            this.dw = null;
            this.dy = null;
            this.b7 = null;
            this.ce = null;
            this.ee = null;
            this.ef = null;
            this.cy = null;
            this.cz = null;
            this.de = null;
            this.dl = null;
            this.dr = null;
            this.dq = null;
            this.dk = null;
            this.cd = null;
            this.ck = null;
            this.cn = null;
            this.ci = null;
            this.ch = null;
            this.ca = null;
            this.b8 = null;
            this.b9 = null;
            this.c5 = null;
            this.dt = null;
            this.ds = null;
            this.c4 = null;
            this.d7 = null;
            this.d2 = null;
            this.d1 = null;
            this.by = null;
            this.eg = null;
            this.ej = null;
            this.di = null;
            this.dj = null;
            this.cm = null;
            this.cl = null;
        }
        get_type() {
            return "WebGridBaseDirective";
        }
        get snackbarDisplayTime() {
            return this.bm;
        }
        set snackbarDisplayTime(a) {
            this.bm = a;
            this.e("SnackbarDisplayTime");
        }
        get autoGenerate() {
            return this.as;
        }
        set autoGenerate(a) {
            this.as = a;
            this.e("AutoGenerate");
        }
        get moving() {
            return this.ay;
        }
        set moving(a) {
            this.ay = a;
            this.e("Moving");
        }
        get emptyGridTemplateRef() {
            return this.cu;
        }
        set emptyGridTemplateRef(a) {
            this.cu = a;
            this.e("EmptyGridTemplateRef");
        }
        get addRowEmptyTemplateRef() {
            return this.bz;
        }
        set addRowEmptyTemplateRef(a) {
            this.bz = a;
            this.e("AddRowEmptyTemplateRef");
        }
        get loadingGridTemplateRef() {
            return this.da;
        }
        set loadingGridTemplateRef(a) {
            this.da = a;
            this.e("LoadingGridTemplateRef");
        }
        get summaryRowHeight() {
            return this.bn;
        }
        set summaryRowHeight(a) {
            this.bn = a;
            this.e("SummaryRowHeight");
        }
        get dataCloneStrategy() {
            return this.w;
        }
        set dataCloneStrategy(a) {
            this.w = a;
            this.e("DataCloneStrategy");
        }
        get clipboardOptions() {
            return this.ae;
        }
        set clipboardOptions(a) {
            this.ae = a;
            this.e("ClipboardOptions");
        }
        get evenRowCSS() {
            return this.cv;
        }
        set evenRowCSS(a) {
            this.cv = a;
            this.e("EvenRowCSS");
        }
        get oddRowCSS() {
            return this.dc;
        }
        set oddRowCSS(a) {
            this.dc = a;
            this.e("OddRowCSS");
        }
        get rowClassesRef() {
            return this.dn;
        }
        set rowClassesRef(a) {
            this.dn = a;
            this.e("RowClassesRef");
        }
        get rowStylesRef() {
            return this.d6;
        }
        set rowStylesRef(a) {
            this.d6 = a;
            this.e("RowStylesRef");
        }
        get primaryKey() {
            return this.dh;
        }
        set primaryKey(a) {
            this.dh = a;
            this.e("PrimaryKey");
        }
        get actionStrip() {
            return this.u;
        }
        set actionStrip(a) {
            this.u = a;
            this.e("ActionStrip");
        }
        get emptyFilteredGridTemplateRef() {
            return this.cr;
        }
        set emptyFilteredGridTemplateRef(a) {
            this.cr = a;
            this.e("EmptyFilteredGridTemplateRef");
        }
        get emptyGridDefaultTemplateRef() {
            return this.cs;
        }
        set emptyGridDefaultTemplateRef(a) {
            this.cs = a;
            this.e("EmptyGridDefaultTemplateRef");
        }
        get dragGhostCustomTemplateRef() {
            return this.co;
        }
        set dragGhostCustomTemplateRef(a) {
            this.co = a;
            this.e("DragGhostCustomTemplateRef");
        }
        get rowEditTextTemplateRef() {
            return this.dz;
        }
        set rowEditTextTemplateRef(a) {
            this.dz = a;
            this.e("RowEditTextTemplateRef");
        }
        get rowAddTextTemplateRef() {
            return this.dm;
        }
        set rowAddTextTemplateRef(a) {
            this.dm = a;
            this.e("RowAddTextTemplateRef");
        }
        get rowEditActionsTemplateRef() {
            return this.dv;
        }
        set rowEditActionsTemplateRef(a) {
            this.dv = a;
            this.e("RowEditActionsTemplateRef");
        }
        get rowExpandedIndicatorTemplateRef() {
            return this.d0;
        }
        set rowExpandedIndicatorTemplateRef(a) {
            this.d0 = a;
            this.e("RowExpandedIndicatorTemplateRef");
        }
        get rowCollapsedIndicatorTemplateRef() {
            return this.dp;
        }
        set rowCollapsedIndicatorTemplateRef(a) {
            this.dp = a;
            this.e("RowCollapsedIndicatorTemplateRef");
        }
        get headerExpandIndicatorTemplateRef() {
            return this.c8;
        }
        set headerExpandIndicatorTemplateRef(a) {
            this.c8 = a;
            this.e("HeaderExpandIndicatorTemplateRef");
        }
        get headerCollapseIndicatorTemplateRef() {
            return this.c7;
        }
        set headerCollapseIndicatorTemplateRef(a) {
            this.c7 = a;
            this.e("HeaderCollapseIndicatorTemplateRef");
        }
        get excelStyleHeaderIconDirectiveTemplateRef() {
            return this.cw;
        }
        set excelStyleHeaderIconDirectiveTemplateRef(a) {
            this.cw = a;
            this.e("ExcelStyleHeaderIconDirectiveTemplateRef");
        }
        get excelStyleHeaderIconTemplateRef() {
            return this.cx;
        }
        set excelStyleHeaderIconTemplateRef(a) {
            this.cx = a;
            this.e("ExcelStyleHeaderIconTemplateRef");
        }
        get sortAscendingHeaderIconTemplateRef() {
            return this.ea;
        }
        set sortAscendingHeaderIconTemplateRef(a) {
            this.ea = a;
            this.e("SortAscendingHeaderIconTemplateRef");
        }
        get sortDescendingHeaderIconDirectiveTemplateRef() {
            return this.eb;
        }
        set sortDescendingHeaderIconDirectiveTemplateRef(a) {
            this.eb = a;
            this.e("SortDescendingHeaderIconDirectiveTemplateRef");
        }
        get sortDescendingHeaderIconTemplateRef() {
            return this.ec;
        }
        set sortDescendingHeaderIconTemplateRef(a) {
            this.ec = a;
            this.e("SortDescendingHeaderIconTemplateRef");
        }
        get sortHeaderIconTemplateRef() {
            return this.ed;
        }
        set sortHeaderIconTemplateRef(a) {
            this.ed = a;
            this.e("SortHeaderIconTemplateRef");
        }
        get toolbar() {
            return this.o;
        }
        set toolbar(a) {
            this.o = a;
            this.e("Toolbar");
        }
        get paginationComponents() {
            return this.m;
        }
        set paginationComponents(a) {
            this.m = a;
            this.e("PaginationComponents");
        }
        get resourceStrings() {
            return this.ag;
        }
        set resourceStrings(a) {
            this.ag = a;
            this.e("ResourceStrings");
        }
        get filteringLogic() {
            return this.c1;
        }
        set filteringLogic(a) {
            this.c1 = a;
            this.e("FilteringLogic");
        }
        get filteringExpressionsTree() {
            return this.z;
        }
        set filteringExpressionsTree(a) {
            this.z = a;
            this.e("FilteringExpressionsTree");
        }
        get advancedFilteringExpressionsTree() {
            return this.y;
        }
        set advancedFilteringExpressionsTree(a) {
            this.y = a;
            this.e("AdvancedFilteringExpressionsTree");
        }
        get locale() {
            return this.db;
        }
        set locale(a) {
            this.db = a;
            this.e("Locale");
        }
        get pagingMode() {
            return this.df;
        }
        set pagingMode(a) {
            this.df = a;
            this.e("PagingMode");
        }
        get paging() {
            return this.az;
        }
        set paging(a) {
            this.az = a;
            this.e("Paging");
        }
        get page() {
            return this.bk;
        }
        set page(a) {
            this.bk = a;
            this.e("Page");
        }
        get perPage() {
            return this.bl;
        }
        set perPage(a) {
            this.bl = a;
            this.e("PerPage");
        }
        get hideRowSelectors() {
            return this.av;
        }
        set hideRowSelectors(a) {
            this.av = a;
            this.e("HideRowSelectors");
        }
        get rowDraggable() {
            return this.a0;
        }
        set rowDraggable(a) {
            this.a0 = a;
            this.e("RowDraggable");
        }
        get validationTrigger() {
            return this.el;
        }
        set validationTrigger(a) {
            this.el = a;
            this.e("ValidationTrigger");
        }
        get dragRowID() {
            return this.bu;
        }
        set dragRowID(a) {
            this.bu = a;
            this.e("DragRowID");
        }
        get rowEditable() {
            return this.a1;
        }
        set rowEditable(a) {
            this.a1 = a;
            this.e("RowEditable");
        }
        get rowHeight() {
            return this.bv;
        }
        set rowHeight(a) {
            this.bv = a;
            this.e("RowHeight");
        }
        get columnWidth() {
            return this.cj;
        }
        set columnWidth(a) {
            this.cj = a;
            this.e("ColumnWidth");
        }
        get emptyGridMessage() {
            return this.ct;
        }
        set emptyGridMessage(a) {
            this.ct = a;
            this.e("EmptyGridMessage");
        }
        get isLoading() {
            return this.aw;
        }
        set isLoading(a) {
            this.aw = a;
            this.e("IsLoading");
        }
        get shouldGenerate() {
            return this.a3;
        }
        set shouldGenerate(a) {
            this.a3 = a;
            this.e("ShouldGenerate");
        }
        get emptyFilteredGridMessage() {
            return this.cq;
        }
        set emptyFilteredGridMessage(a) {
            this.cq = a;
            this.e("EmptyFilteredGridMessage");
        }
        get pinning() {
            return this.am;
        }
        set pinning(a) {
            this.am = a;
            this.e("Pinning");
        }
        get allowFiltering() {
            return this.ar;
        }
        set allowFiltering(a) {
            this.ar = a;
            this.e("AllowFiltering");
        }
        get allowAdvancedFiltering() {
            return this.aq;
        }
        set allowAdvancedFiltering(a) {
            this.aq = a;
            this.e("AllowAdvancedFiltering");
        }
        get filterMode() {
            return this.c2;
        }
        set filterMode(a) {
            this.c2 = a;
            this.e("FilterMode");
        }
        get summaryPosition() {
            return this.ei;
        }
        set summaryPosition(a) {
            this.ei = a;
            this.e("SummaryPosition");
        }
        get summaryCalculationMode() {
            return this.eh;
        }
        set summaryCalculationMode(a) {
            this.eh = a;
            this.e("SummaryCalculationMode");
        }
        get showSummaryOnCollapse() {
            return this.a4;
        }
        set showSummaryOnCollapse(a) {
            this.a4 = a;
            this.e("ShowSummaryOnCollapse");
        }
        get filterStrategy() {
            return this.ac;
        }
        set filterStrategy(a) {
            this.ac = a;
            this.e("FilterStrategy");
        }
        get sortStrategy() {
            return this.ai;
        }
        set sortStrategy(a) {
            this.ai = a;
            this.e("SortStrategy");
        }
        get sortingOptions() {
            return this.ao;
        }
        set sortingOptions(a) {
            this.ao = a;
            this.e("SortingOptions");
        }
        get selectedRowsRef() {
            return this.d9;
        }
        set selectedRowsRef(a) {
            this.d9 = a;
            this.e("SelectedRowsRef");
        }
        get headSelectorTemplateRef() {
            return this.c9;
        }
        set headSelectorTemplateRef(a) {
            this.c9 = a;
            this.e("HeadSelectorTemplateRef");
        }
        get rowSelectorTemplateRef() {
            return this.d5;
        }
        set rowSelectorTemplateRef(a) {
            this.d5 = a;
            this.e("RowSelectorTemplateRef");
        }
        get dragIndicatorIconTemplateRef() {
            return this.cp;
        }
        set dragIndicatorIconTemplateRef(a) {
            this.cp = a;
            this.e("DragIndicatorIconTemplateRef");
        }
        get sortingExpressions() {
            return this.n;
        }
        set sortingExpressions(a) {
            this.n = a;
            this.e("SortingExpressions");
        }
        get batchEditing() {
            return this.at;
        }
        set batchEditing(a) {
            this.at = a;
            this.e("BatchEditing");
        }
        get cellSelection() {
            return this.b6;
        }
        set cellSelection(a) {
            this.b6 = a;
            this.e("CellSelection");
        }
        get rowSelection() {
            return this.d3;
        }
        set rowSelection(a) {
            this.d3 = a;
            this.e("RowSelection");
        }
        get columnSelection() {
            return this.cf;
        }
        set columnSelection(a) {
            this.cf = a;
            this.e("ColumnSelection");
        }
        get isPivot() {
            return this.ax;
        }
        set isPivot(a) {
            this.ax = a;
            this.e("IsPivot");
        }
        get outlet() {
            return this.ak;
        }
        set outlet(a) {
            this.ak = a;
            this.e("Outlet");
        }
        get columns() {
            return this.l;
        }
        set columns(a) {
            this.l = a;
            this.e("Columns");
        }
        get totalRecords() {
            return this.bo;
        }
        set totalRecords(a) {
            this.bo = a;
            this.e("TotalRecords");
        }
        get hasVisibleColumns() {
            return this.au;
        }
        set hasVisibleColumns(a) {
            this.au = a;
            this.e("HasVisibleColumns");
        }
        get selectRowOnClick() {
            return this.a2;
        }
        set selectRowOnClick(a) {
            this.a2 = a;
            this.e("SelectRowOnClick");
        }
        get actualColumns() {
            return this.k;
        }
        set actualColumns(a) {
            this.k = a;
            this.e("ActualColumns");
        }
        get filteringExpressionsTreeChangeRef() {
            return this.c0;
        }
        set filteringExpressionsTreeChangeRef(a) {
            this.c0 = a;
            this.e("FilteringExpressionsTreeChangeRef");
        }
        get advancedFilteringExpressionsTreeChangeRef() {
            return this.b0;
        }
        set advancedFilteringExpressionsTreeChangeRef(a) {
            this.b0 = a;
            this.e("AdvancedFilteringExpressionsTreeChangeRef");
        }
        get gridScrollRef() {
            return this.c6;
        }
        set gridScrollRef(a) {
            this.c6 = a;
            this.e("GridScrollRef");
        }
        get pageChangeRef() {
            return this.dd;
        }
        set pageChangeRef(a) {
            this.dd = a;
            this.e("PageChangeRef");
        }
        get perPageChangeRef() {
            return this.dg;
        }
        set perPageChangeRef(a) {
            this.dg = a;
            this.e("PerPageChangeRef");
        }
        get cellClickRef() {
            return this.b1;
        }
        set cellClickRef(a) {
            this.b1 = a;
            this.e("CellClickRef");
        }
        get formGroupCreatedRef() {
            return this.c3;
        }
        set formGroupCreatedRef(a) {
            this.c3 = a;
            this.e("FormGroupCreatedRef");
        }
        get validationStatusChangeRef() {
            return this.ek;
        }
        set validationStatusChangeRef(a) {
            this.ek = a;
            this.e("ValidationStatusChangeRef");
        }
        get selectedRef() {
            return this.d8;
        }
        set selectedRef(a) {
            this.d8 = a;
            this.e("SelectedRef");
        }
        get rowSelectionChangingRef() {
            return this.d4;
        }
        set rowSelectionChangingRef(a) {
            this.d4 = a;
            this.e("RowSelectionChangingRef");
        }
        get columnSelectionChangingRef() {
            return this.cg;
        }
        set columnSelectionChangingRef(a) {
            this.cg = a;
            this.e("ColumnSelectionChangingRef");
        }
        get columnPinRef() {
            return this.cb;
        }
        set columnPinRef(a) {
            this.cb = a;
            this.e("ColumnPinRef");
        }
        get columnPinnedRef() {
            return this.cc;
        }
        set columnPinnedRef(a) {
            this.cc = a;
            this.e("ColumnPinnedRef");
        }
        get cellEditEnterRef() {
            return this.b4;
        }
        set cellEditEnterRef(a) {
            this.b4 = a;
            this.e("CellEditEnterRef");
        }
        get cellEditExitRef() {
            return this.b5;
        }
        set cellEditExitRef(a) {
            this.b5 = a;
            this.e("CellEditExitRef");
        }
        get cellEditRef() {
            return this.b2;
        }
        set cellEditRef(a) {
            this.b2 = a;
            this.e("CellEditRef");
        }
        get cellEditDoneRef() {
            return this.b3;
        }
        set cellEditDoneRef(a) {
            this.b3 = a;
            this.e("CellEditDoneRef");
        }
        get rowEditEnterRef() {
            return this.dx;
        }
        set rowEditEnterRef(a) {
            this.dx = a;
            this.e("RowEditEnterRef");
        }
        get rowEditRef() {
            return this.du;
        }
        set rowEditRef(a) {
            this.du = a;
            this.e("RowEditRef");
        }
        get rowEditDoneRef() {
            return this.dw;
        }
        set rowEditDoneRef(a) {
            this.dw = a;
            this.e("RowEditDoneRef");
        }
        get rowEditExitRef() {
            return this.dy;
        }
        set rowEditExitRef(a) {
            this.dy = a;
            this.e("RowEditExitRef");
        }
        get columnInitRef() {
            return this.b7;
        }
        set columnInitRef(a) {
            this.b7 = a;
            this.e("ColumnInitRef");
        }
        get columnsAutogeneratedRef() {
            return this.ce;
        }
        set columnsAutogeneratedRef(a) {
            this.ce = a;
            this.e("ColumnsAutogeneratedRef");
        }
        get sortingRef() {
            return this.ee;
        }
        set sortingRef(a) {
            this.ee = a;
            this.e("SortingRef");
        }
        get sortingDoneRef() {
            return this.ef;
        }
        set sortingDoneRef(a) {
            this.ef = a;
            this.e("SortingDoneRef");
        }
        get filteringRef() {
            return this.cy;
        }
        set filteringRef(a) {
            this.cy = a;
            this.e("FilteringRef");
        }
        get filteringDoneRef() {
            return this.cz;
        }
        set filteringDoneRef(a) {
            this.cz = a;
            this.e("FilteringDoneRef");
        }
        get pagingDoneRef() {
            return this.de;
        }
        set pagingDoneRef(a) {
            this.de = a;
            this.e("PagingDoneRef");
        }
        get rowAddedRef() {
            return this.dl;
        }
        set rowAddedRef(a) {
            this.dl = a;
            this.e("RowAddedRef");
        }
        get rowDeletedRef() {
            return this.dr;
        }
        set rowDeletedRef(a) {
            this.dr = a;
            this.e("RowDeletedRef");
        }
        get rowDeleteRef() {
            return this.dq;
        }
        set rowDeleteRef(a) {
            this.dq = a;
            this.e("RowDeleteRef");
        }
        get rowAddRef() {
            return this.dk;
        }
        set rowAddRef(a) {
            this.dk = a;
            this.e("RowAddRef");
        }
        get columnResizedRef() {
            return this.cd;
        }
        set columnResizedRef(a) {
            this.cd = a;
            this.e("ColumnResizedRef");
        }
        get contextMenuRef() {
            return this.ck;
        }
        set contextMenuRef(a) {
            this.ck = a;
            this.e("ContextMenuRef");
        }
        get doubleClickRef() {
            return this.cn;
        }
        set doubleClickRef(a) {
            this.cn = a;
            this.e("DoubleClickRef");
        }
        get columnVisibilityChangingRef() {
            return this.ci;
        }
        set columnVisibilityChangingRef(a) {
            this.ci = a;
            this.e("ColumnVisibilityChangingRef");
        }
        get columnVisibilityChangedRef() {
            return this.ch;
        }
        set columnVisibilityChangedRef(a) {
            this.ch = a;
            this.e("ColumnVisibilityChangedRef");
        }
        get columnMovingStartRef() {
            return this.ca;
        }
        set columnMovingStartRef(a) {
            this.ca = a;
            this.e("ColumnMovingStartRef");
        }
        get columnMovingRef() {
            return this.b8;
        }
        set columnMovingRef(a) {
            this.b8 = a;
            this.e("ColumnMovingRef");
        }
        get columnMovingEndRef() {
            return this.b9;
        }
        set columnMovingEndRef(a) {
            this.b9 = a;
            this.e("ColumnMovingEndRef");
        }
        get gridKeydownRef() {
            return this.c5;
        }
        set gridKeydownRef(a) {
            this.c5 = a;
            this.e("GridKeydownRef");
        }
        get rowDragStartRef() {
            return this.dt;
        }
        set rowDragStartRef(a) {
            this.dt = a;
            this.e("RowDragStartRef");
        }
        get rowDragEndRef() {
            return this.ds;
        }
        set rowDragEndRef(a) {
            this.ds = a;
            this.e("RowDragEndRef");
        }
        get gridCopyRef() {
            return this.c4;
        }
        set gridCopyRef(a) {
            this.c4 = a;
            this.e("GridCopyRef");
        }
        get rowToggleRef() {
            return this.d7;
        }
        set rowToggleRef(a) {
            this.d7 = a;
            this.e("RowToggleRef");
        }
        get rowPinningRef() {
            return this.d2;
        }
        set rowPinningRef(a) {
            this.d2 = a;
            this.e("RowPinningRef");
        }
        get rowPinnedRef() {
            return this.d1;
        }
        set rowPinnedRef(a) {
            this.d1 = a;
            this.e("RowPinnedRef");
        }
        get activeNodeChangeRef() {
            return this.by;
        }
        set activeNodeChangeRef(a) {
            this.by = a;
            this.e("ActiveNodeChangeRef");
        }
        get sortingExpressionsChangeRef() {
            return this.eg;
        }
        set sortingExpressionsChangeRef(a) {
            this.eg = a;
            this.e("SortingExpressionsChangeRef");
        }
        get toolbarExportingRef() {
            return this.ej;
        }
        set toolbarExportingRef(a) {
            this.ej = a;
            this.e("ToolbarExportingRef");
        }
        get rangeSelectedRef() {
            return this.di;
        }
        set rangeSelectedRef(a) {
            this.di = a;
            this.e("RangeSelectedRef");
        }
        get renderedRef() {
            return this.dj;
        }
        set renderedRef(a) {
            this.dj = a;
            this.e("RenderedRef");
        }
        get dataChangingRef() {
            return this.cm;
        }
        set dataChangingRef(a) {
            this.cm = a;
            this.e("DataChangingRef");
        }
        get dataChangedRef() {
            return this.cl;
        }
        set dataChangedRef(a) {
            this.cl = a;
            this.e("DataChangedRef");
        }
    }
    WebGridBaseDirectiveDescription.$t = /*@__PURE__*/ markType(WebGridBaseDirectiveDescription, 'WebGridBaseDirectiveDescription', WebDisplayDensityBaseDescription.$);
    return WebGridBaseDirectiveDescription;
})();
/**
 * @hidden
 */
export let WebGridToolbarDescription = /*@__PURE__*/ (() => {
    class WebGridToolbarDescription extends WebDisplayDensityBaseElementDescription {
        constructor() {
            super();
            this.o = false;
            this.m = null;
            this.q = null;
            this.k = null;
        }
        get_type() {
            return "WebGridToolbar";
        }
        get showProgress() {
            return this.o;
        }
        set showProgress(a) {
            this.o = a;
            this.e("ShowProgress");
        }
        get grid() {
            return this.m;
        }
        set grid(a) {
            this.m = a;
            this.e("Grid");
        }
        get name() {
            return this.q;
        }
        set name(a) {
            this.q = a;
            this.e("Name");
        }
        get tools() {
            return this.k;
        }
        set tools(a) {
            this.k = a;
            this.e("Tools");
        }
    }
    WebGridToolbarDescription.$t = /*@__PURE__*/ markType(WebGridToolbarDescription, 'WebGridToolbarDescription', WebDisplayDensityBaseElementDescription.$);
    return WebGridToolbarDescription;
})();
